Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 37252)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 37253)
@@ -20,12 +20,13 @@
 
 LangString VBOX_COMPONENT_MAIN ${LANG_ENGLISH}                      "VirtualBox Guest Additions"
-LangString VBOX_COMPONENT_MAIN_DESC ${LANG_ENGLISH}                 "Main Files of VirtualBox Guest Additions"
-LangString VBOX_COMPONENT_AUTOLOGON ${LANG_ENGLISH}                 "Auto-Logon Support"
+LangString VBOX_COMPONENT_MAIN_DESC ${LANG_ENGLISH}                 "Main files of VirtualBox Guest Additions"
+LangString VBOX_COMPONENT_AUTOLOGON ${LANG_ENGLISH}                 "Auto-Logon support"
 LangString VBOX_COMPONENT_AUTOLOGON_DESC ${LANG_ENGLISH}            "Enables auto-logon support for guests"
 LangString VBOX_COMPONENT_AUTOLOGON_WARN_3RDPARTY ${LANG_ENGLISH}   "There already is a component installed for providing auto-logon support.$\r$\nIf you replace this component with the one from VirtualBox, the system could become unstable.$\r$\nReplace it anyway?"
 LangString VBOX_COMPONENT_D3D  ${LANG_ENGLISH}                      "Direct3D Support (Experimental)"
-LangString VBOX_COMPONENT_D3D_DESC  ${LANG_ENGLISH}                 "Enables Direct3D Support for guests (Experimental)"
+LangString VBOX_COMPONENT_D3D_DESC  ${LANG_ENGLISH}                 "Enables Direct3D support for guests (Experimental)"
 LangString VBOX_COMPONENT_D3D_NO_SM ${LANG_ENGLISH}                 "Windows is currently not started in safe mode.$\r$\nTherefore the D3D support cannot be installed."
 LangString VBOX_COMPONENT_D3D_NOT_SUPPORTED ${LANG_ENGLISH}         "Direct3D guest support not available on Windows $g_strWinVersion!"
+LangString VBOX_COMPONENT_D3D_OR_WDDM ${LANG_ENGLISH}               "On this guest Windows Aero (WDDM) is supported.$\r$\nThis feature is experimental and therefore should not be used on productive systems yet.$\r$\n$\r$\nDo you want to install the regular Direct3D support instead?"
 
 LangString VBOX_WFP_WARN_REPLACE ${LANG_ENGLISH}         "The setup just has replaced some system files in order to make ${PRODUCT_NAME} work correctly.$\r$\nIn case Windows File Protection shows a warning dialog, please cancel its suggestion of restoring the original files."
Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 37252)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 37253)
@@ -28,4 +28,5 @@
 LangString VBOX_COMPONENT_D3D_NO_SM ${LANG_FRENCH}                  "Windows ne fonctionne pas en mode sans échec.$\r$\nDe ce fait, le support D3D ne peut être installé."
 LangString VBOX_COMPONENT_D3D_NOT_SUPPORTED ${LANG_FRENCH}          "Le support invité pour Direct3D n'est pas disponible sur Windows $g_strWinVersion!"
+LangString VBOX_COMPONENT_D3D_OR_WDDM ${LANG_FRENCH}                "On this guest Windows Aero (WDDM) is supported.$\r$\nThis feature is experimental and therefore should not be used on productive systems yet.$\r$\n$\r$\nDo you want to install the regular Direct3D support instead?"
 
 LangString VBOX_WFP_WARN_REPLACE ${LANG_FRENCH}          "Le programme d'installation vient de remplacer certains fichiers systèmes afin de faire fonctionner correctement ${PRODUCT_NAME}.$\r$\nPour le cas qu'un avertissement de la Protection de fichiers Windows apparaisse, veuiller l'annuler sans restaurer les fichiers originaux!"
Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 37252)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 37253)
@@ -28,4 +28,5 @@
 LangString VBOX_COMPONENT_D3D_NO_SM ${LANG_GERMAN}                  "Windows befindet sich aktuell nicht im abgesicherten Modus.$\r$\nDaher kann die D3D-Unterstützung nicht installiert werden."
 LangString VBOX_COMPONENT_D3D_NOT_SUPPORTED ${LANG_GERMAN}          "Direct3D Gast-Unterstützung nicht verfügbar unter Windows $g_strWinVersion!"
+LangString VBOX_COMPONENT_D3D_OR_WDDM ${LANG_GERMAN}                "Für diesen Gast ist Windows Aero (WDDM)-Unterstützung verfügbar.$\r$\nDieses Feature ist jedoch noch experimentell und sollte daher noch nicht auf produktiven Systemen eingesetzt werden.$\r$\n$\r$\nMöchten Sie stattdessen die reguläre Direct3D-Unterstützung installieren?"
 
 LangString VBOX_WFP_WARN_REPLACE ${LANG_GERMAN}         "Das Setup hat gerade Systemdateien ersetzt um die ${PRODUCT_NAME} korrekt installieren zu können.$\r$\nFalls nun ein Warn-Dialog des Windows-Dateischutzes erscheint, diesen bitte abbrechen und die Dateien nicht wiederherstellen lassen!"
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi	(revision 37252)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi	(revision 37253)
@@ -212,5 +212,5 @@
 Var g_strWinVersion                     ; Current Windows version we're running on
 Var g_bLogEnable                        ; Do logging when installing? "true" or "false"
-Var g_bWithWDDM                         ; Install the WDDM driver instead of the normal one
+Var g_bWithWDDM                         ; Install the WDDM driver instead of the XPDM one
 Var g_bCapWDDM                          ; Capability: Is the guest able to handle/use our WDDM driver?
 
@@ -965,7 +965,16 @@
     ; D3D components below
     ${If} $g_bCapWDDM == "true"
+      ;
+      ; Temporary solution: Since WDDM is marked as experimental yet we notify the user
+      ; that WDDM (Aero) support is available but not recommended for production use. He now
+      ; can opt-in for installing WDDM or still go for the old (XPDM) way -- safe mode still required!
+      ;
+      MessageBox MB_ICONQUESTION|MB_YESNO $(VBOX_COMPONENT_D3D_OR_WDDM) /SD IDNO IDYES d3d_install
       StrCpy $g_bWithWDDM "true"
       Goto exit
     ${EndIf}
+
+d3d_install:
+
 !endif
 